#pragma once

#include <stdint.h>

typedef struct {
    uint16_t signature;
    uint16_t type;
    uint32_t location;
    uint32_t size;
    char field1_0xc;
    char field2_0xd;
    char field3_0xe;
    char field4_0xf;
    char name[20];
} afs_entry_t;

typedef struct {
    int32_t used;
    int32_t cursor;
    afs_entry_t* entry;
} afs_file_descriptor_t;

typedef struct {
    disc_file_descriptor_t *discDescriptor;
    char field1_0x4;
    char field2_0x5;
    char field3_0x6;
    char field4_0x7;
    int32_t entriesOffset;
    afs_entry_t* entries;
    int32_t numberEntries;
    int32_t field8_0x14;
    afs_file_descriptor_t* fileDescriptors;
} afs_volume_t;

int AfsGetEntry(afs_volume_t* handle);
afs_entry_t* AfsFind(afs_volume_t* handle, const char* path, unsigned short flags);
int AfsOpenVolume(afs_volume_t* handle, const char* path);
void AfsInit(afs_volume_t* handle);
afs_file_descriptor_t* AfsOpen(afs_volume_t* handle, const char* path);
int AfsClose(afs_file_descriptor_t* fd);
int AfsFileSize(afs_volume_t* volume, afs_file_descriptor_t* fd);
int AfsRead(afs_volume_t* volume, afs_file_descriptor_t* fd, void* buffer, int length);
int AfsCheckMagic(afs_volume_t* handle);
